## psi-notify 1.3.1

=== Makefile ===
CFLAGS:=-std=gnu11 -O2 -pedantic -Wall -Wextra -Werror $(shell pkg-config --cflags libnotify) $(CFLAGS)
LDFLAGS:=$(shell pkg-config --libs libnotify) $(LDFLAGS)

INSTALL:=install
prefix:=/usr/local
bindir:=$(prefix)/bin
datarootdir:=$(prefix)/share
mandir:=$(datarootdir)/man


WANT_SD_NOTIFY=1
HAS_LIBSYSTEMD=$(shell pkg-config libsystemd && echo 1 || echo 0)

ifeq ($(HAS_LIBSYSTEMD),0)
$(warning libsystemd not found, setting WANT_SD_NOTIFY=0)
WANT_SD_NOTIFY=0
endif

ifeq ($(WANT_SD_NOTIFY),1)
CFLAGS+=-DWANT_SD_NOTIFY $(shell pkg-config --cflags libsystemd)
LDFLAGS+=$(shell pkg-config --libs libsystemd)
endif

SOURCES=$(wildcard *.c)
EXECUTABLES=$(patsubst %.c,%,$(SOURCES))

.PHONY: test

all: $(EXECUTABLES)

%: %.c
	$(CC) $(CFLAGS) $< -o $@ $(LIBS) $(LDFLAGS)

%.o: %.c
	$(CC) $(CFLAGS) $< -c -o $@

%: %.o
	$(CC) $< -o $@ $(LIBS) $(LDFLAGS)

# Noisy clang build that's expected to fail, but can be useful to find corner
# cases.
clang-everything: CC=clang
clang-everything: CFLAGS+=-Weverything -Wno-disabled-macro-expansion -Wno-padded -Wno-unused-macros -Wno-covered-switch-default
clang-everything: all

sanitisers: CFLAGS+=-fsanitize=address -fsanitize=undefined
sanitisers: debug

debug: CFLAGS+=-Og -ggdb -fno-omit-frame-pointer
debug: all

afl: CC=afl-gcc
afl: CFLAGS+=-DWANT_FUZZER
afl: export AFL_HARDEN=1 AFL_USE_ASAN=1
afl: sanitisers

fuzz-configs: afl
	fuzz/configs/run

fuzz-pressures: afl
	fuzz/pressures/run

clang-tidy:
	# DeprecatedOrUnsafeBufferHandling: See https://stackoverflow.com/a/50724865/945780
	clang-tidy psi-notify.c -checks=-clang-analyzer-security.insecureAPI.DeprecatedOrUnsafeBufferHandling -- $(CFLAGS) $(LDFLAGS)

install: all
	mkdir -p $(DESTDIR)$(bindir)/
	$(INSTALL) -pt $(DESTDIR)$(bindir)/ $(EXECUTABLES)
	$(INSTALL) -Dp -m 644 psi-notify.service $(DESTDIR)$(prefix)/lib/systemd/user/psi-notify.service
	$(INSTALL) -Dp -m 644 psi-notify.1 $(DESTDIR)$(mandir)/man1/psi-notify.1

test: CFLAGS+=-D_FORTIFY_SOURCE=2 -fsanitize=address -fsanitize=undefined -Og -ggdb -fno-omit-frame-pointer
test:
	$(CC) $(CFLAGS) test/test.c -o test/test $(LIBS) $(LDFLAGS)
	test/test

clean:
	rm -f $(EXECUTABLES) test/test

=== debian/changelog ===
psi-notify (1.3.1-1) unstable; urgency=low

  * Update to 1.3.1
  * Patches now upstreamed
  * Allows running tests on systems with PSI disabled
  * manpage now included

 -- Michel Alexandre Salim <michel@michel-slm.name>  Fri, 12 Aug 2022 14:00:24 -0500

psi-notify (1.3.0-1) unstable; urgency=low

  * Update to 1.3.0
  * add `make install`
  * `README.md`: update link to desktop notifications spec
  * `README.md`: add links to Debian and Ubuntu packages and Repology

 -- Michel Alexandre Salim <michel@michel-slm.name>  Wed, 03 Aug 2022 14:40:01 -0500

psi-notify (1.2.1-3) unstable; urgency=low

  * Fix license (should be Expat not MIT)
  * Add copyright for Debian packaging files
  * Be more explicit: s/install/psi-notify.install
  * Narrow supported architectures to linux-any
  * Build with hardening=+all
  * Add upstream/metadata
  * Drop libnotify-bin runtime dependency
  * Fix rename rule in watch

 -- Michel Alexandre Salim <michel@michel-slm.name>  Thu, 12 May 2022 22:30:00 +0000

psi-notify (1.2.1-2) unstable; urgency=low

  * Add debian/watch file

 -- Michel Alexandre Salim <michel@michel-slm.name>  Tue, 10 May 2022 02:55:44 +0000

psi-notify (1.2.1-1) unstable; urgency=low

  * Initial release (Closes: #1010778)

 -- Michel Alexandre Salim <michel@michel-slm.name>  Mon, 09 May 2022 21:15:44 +0000

=== debian/control ===
Source: psi-notify
Section: utils
Priority: optional
Maintainer: Michel Alexandre Salim <michel@michel-slm.name>
Build-Depends:
 debhelper-compat (= 13),
 libnotify-dev,
 libsystemd-dev,
 pkg-config,
Standards-Version: 4.6.0
Homepage: https://github.com/cdown/psi-notify
Vcs-Browser: https://salsa.debian.org/michel/psi-notify
Vcs-Git: https://salsa.debian.org/michel/psi-notify.git
Rules-Requires-Root: no

Package: psi-notify
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Alert when your machine is becoming oversaturated
 psi-notify is a minimal unprivileged notifier for system-wide resource pressure
 using PSI. This can help you to identify misbehaving applications on your
 machine before they start to severely impact system responsiveness, in a way
 which MemAvailable, CPU graphs, I/O utilisation graphs and other metrics
 cannot.

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/psi-notify-$1\.tar\.gz/ \
  https://github.com/cdown/psi-notify/tags .*/v?(\d\S+)\.tar\.gz
